﻿using System;
using System.IO;
using System.Diagnostics;
namespace wc24encrypt
{
    public class main
    {
        public static void Main(string[] args)
        {
            Console.WriteLine("wc24encrypt by Markus Kostrzewski");
            if (args.Length != 3)
            {
                Console.WriteLine("Usage: wc24encrypt <input.bin> <output.bin> <key.bin>");
                Environment.Exit(1);
            }
            string IV = "0AE50A9D24EF9A2872B09A3F13E5406A";
            string Key = BitConverter.ToString(File.ReadAllBytes(args[2])).Replace("-", "");
            var p = new Process();
            var pi = new ProcessStartInfo("openssl", String.Format("enc -aes-128-ofb -in {0} -out {1}.tmp -K {2} -iv {3}", args[0], args[1], Key, IV));
            p.StartInfo = pi;
            Console.WriteLine("Encrypting content...");
            p.Start();
            p.WaitForExit();
            Console.WriteLine("Adding header...");
            byte[] header = File.ReadAllBytes("wc24header.bin");
            byte[] data = File.ReadAllBytes(String.Format("{0}.tmp", args[1]));
            var s = new MemoryStream();
            s.Write(header, 0, header.Length);
            s.Write(data, 0, data.Length);
            File.WriteAllBytes(args[1], s.ToArray());
            File.Delete(String.Format("{0}.tmp", args[1]));
            Console.WriteLine("Encryption finished.");
        }

    }
}